<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseStarDay ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseStarDay extends AbstractStructArrayBase
{
    /**
     * The StarDay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseStarDay[]
     */
    public $StarDay;
    /**
     * Constructor method for ArrayOfJP_CruiseStarDay
     * @uses ArrayOfJP_CruiseStarDay::setStarDay()
     * @param \StructType\JP_CruiseStarDay[] $starDay
     */
    public function __construct(array $starDay = array())
    {
        $this
            ->setStarDay($starDay);
    }
    /**
     * Get StarDay value
     * @return \StructType\JP_CruiseStarDay[]|null
     */
    public function getStarDay()
    {
        return $this->StarDay;
    }
    /**
     * This method is responsible for validating the values passed to the setStarDay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStarDay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStarDayForArrayConstraintsFromSetStarDay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CruiseStarDayStarDayItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseStarDayStarDayItem instanceof \StructType\JP_CruiseStarDay) {
                $invalidValues[] = is_object($arrayOfJP_CruiseStarDayStarDayItem) ? get_class($arrayOfJP_CruiseStarDayStarDayItem) : sprintf('%s(%s)', gettype($arrayOfJP_CruiseStarDayStarDayItem), var_export($arrayOfJP_CruiseStarDayStarDayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The StarDay property can only contain items of type \StructType\JP_CruiseStarDay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set StarDay value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseStarDay[] $starDay
     * @return \ArrayType\ArrayOfJP_CruiseStarDay
     */
    public function setStarDay(array $starDay = array())
    {
        // validation for constraint: array
        if ('' !== ($starDayArrayErrorMessage = self::validateStarDayForArrayConstraintsFromSetStarDay($starDay))) {
            throw new \InvalidArgumentException($starDayArrayErrorMessage, __LINE__);
        }
        $this->StarDay = $starDay;
        return $this;
    }
    /**
     * Add item to StarDay value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseStarDay $item
     * @return \ArrayType\ArrayOfJP_CruiseStarDay
     */
    public function addToStarDay(\StructType\JP_CruiseStarDay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseStarDay) {
            throw new \InvalidArgumentException(sprintf('The StarDay property can only contain items of type \StructType\JP_CruiseStarDay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->StarDay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseStarDay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StarDay
     */
    public function getAttributeName()
    {
        return 'StarDay';
    }
}
